
Partial Class NorthwindDS

    Partial Class SuppliersRow

        ''' <summary>
        ''' Gets all products for the current supplier
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function GetProducts() As NorthwindDS.ProductsDataTable
            Dim adapter As New NorthwindDSTableAdapters.ProductsTableAdapter
            Return adapter.GetDataBySupplierId(Me.SupplierID)
        End Function
    End Class

End Class

Namespace NorthwindDSTableAdapters

    Partial Class ProductsTableAdapter

        ''' <summary>
        ''' Gets the products but allows sorting and paging
        ''' </summary>
        ''' <param name="sortColumns"></param>
        ''' <param name="startIndex"></param>
        ''' <param name="maxRows"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function GetProducts(ByVal sortColumns As String, ByVal startIndex As Integer, ByVal maxRows As Integer) As NorthwindDS.ProductsDataTable
            Adapter.SelectCommand = CommandCollection(0)

            If Not (String.IsNullOrEmpty(sortColumns)) Then
                Adapter.SelectCommand.CommandText &= " ORDER BY " & sortColumns
            End If

            Dim ds As New NorthwindDS
            Adapter.Fill(startIndex, maxRows, New DataTable() {ds.Products})
            Return ds.Products
        End Function
    End Class
End Namespace